#include "stdafx.h"
#include <windows.h>
#include "scripts.h"
char *noparams = 0;
HINSTANCE wwscripts;
cs CreateScript;
ds DestroyScript;
gsc GetScriptCount;
gsn GetScriptName;
rdf ScriptImpClass::RequestDestroyScript;
gspd GetScriptParamDescription;
srdf SetRequestDestroyFunc;
DWORD OldCount;
ScriptCommandsClass *Commands;
ssc SetScriptCommands;
ScriptClass *scr1;
extern "C"
{

BOOL __declspec(dllexport) __stdcall DllMain( HANDLE hModule, 
						DWORD	ul_reason_for_call, 
						LPVOID	lpReserved
					 )
{
	switch (ul_reason_for_call)
	{
		case DLL_PROCESS_ATTACH:
			wwscripts = LoadLibrary("scripts2.dll");
			if (wwscripts) {
				CreateScript = (cs) GetProcAddress(wwscripts,"Create_Script");
				DestroyScript = (ds) GetProcAddress(wwscripts,"Destroy_Script");
				GetScriptCount = (gsc) GetProcAddress(wwscripts,"Get_Script_Count");
				GetScriptName = (gsn) GetProcAddress(wwscripts,"Get_Script_Name");
				GetScriptParamDescription = (gspd) GetProcAddress(wwscripts,"Get_Script_Param_Description");
				SetScriptCommands = (ssc) GetProcAddress(wwscripts,"Set_Script_Commands");
				SetRequestDestroyFunc = (srdf) GetProcAddress(wwscripts,"Set_Request_Destroy_Func");
				OldCount = (GetScriptCount) ();
			} else {
				MessageBox(HWND_DESKTOP,"Error","Scripts2.dll not found",MB_OK|MB_ICONEXCLAMATION);
				return FALSE;
			}
			break;
		case DLL_PROCESS_DETACH:
			FreeLibrary(wwscripts);
			break;
	}
	return TRUE;
}

ScriptClass __declspec(dllexport) *Create_Script(const char *ScriptName)
{
	if (ScriptName == NULL) {
		return 0;
	}
	ScriptClass *scr = ScriptRegistrar::CreateScript(ScriptName);
	if (scr != 0) {
		return scr;
	}
	return (CreateScript) (ScriptName);
}

void __declspec(dllexport) Destroy_Script(ScriptClass *scr)
{
	if (scr != 0) {
		delete scr;
	}
}

DWORD __declspec(dllexport) Get_Script_Count()
{
	int sn = 0;
	sn = ScriptRegistrar::Count();
	return (GetScriptCount) () + sn;
}

char __declspec(dllexport) *Get_Script_Name(DWORD Number)
{
	if (Number < OldCount) {
		return (GetScriptName) (Number);
	}
	int n = Number - OldCount;
	return ScriptRegistrar::GetScriptFactory(n)->GetName();
}

char __declspec(dllexport) *Get_Script_Param_Description(DWORD Number)
{
	if (Number < OldCount) {
		return (GetScriptParamDescription) (Number);
	}
	int n = Number - OldCount;
	return ScriptRegistrar::GetScriptFactory(n)->GetParamDescription();
}

bool __declspec(dllexport) Set_Script_Commands(ScriptCommandsClass **ScriptCommands)
{
	Commands = *ScriptCommands;
	return (SetScriptCommands) (ScriptCommands);
}

void __declspec(dllexport) Set_Request_Destroy_Func(rdf Func)
{
	ScriptImpClass::Set_Request_Destroy_Func(Func);
	(SetRequestDestroyFunc) (Func);
}

} //extern "C"
ScriptImpClass::ScriptImpClass()
{
	data1 = 0;
	OwnerAddr = 0;
	mArgC = 0;
	mArgV = 0;
	seralizeinfo = NULL;
}
char *ScriptImpClass::Get_Name()
{
	return Factory->GetName();
}
void ScriptImpClass::Attatch(GameObject * newobj)
{
	OwnerAddr = newobj;
}
void ScriptImpClass::Set_Request_Destroy_Func(rdf Func)
{
	RequestDestroyScript = Func;
}
void ScriptImpClass::Destroy_Script()
{
	if (RequestDestroyScript != 0) {
	(RequestDestroyScript) (this);
	}
}
void ScriptImpClass::Detatch(GameObject * obj)
{
	OwnerAddr = 0;
	Destroy_Script();
}
void ScriptImpClass::Created(GameObject * obj)
{
}
void ScriptImpClass::Destroyed(GameObject * obj)
{
}
void ScriptImpClass::Damaged(GameObject * obj,GameObject * damager,float damage)
{
}
void ScriptImpClass::Killed(GameObject * obj,GameObject * shooter)
{
}
void ScriptImpClass::Sound_Heard(GameObject * obj,DWORD sound)
{
}
void ScriptImpClass::Custom(GameObject * obj,int message,int param,GameObject * sender)
{
}
void ScriptImpClass::Action_Complete(GameObject * obj,int action,ActionCompleteReason reason)
{
}
void ScriptImpClass::Enemy_Seen(GameObject * obj,GameObject * seen)
{
}
void ScriptImpClass::Timer_Expired(GameObject * obj,int number)
{
}
void ScriptImpClass::Animation_Complete(GameObject * obj,const char *anim)
{
}
void ScriptImpClass::Poked(GameObject * obj,GameObject * poker)
{
}
void ScriptImpClass::Entered(GameObject * obj,GameObject * enter)
{
}
void ScriptImpClass::Exited(GameObject * obj,GameObject * exit)
{
}
GameObject * ScriptImpClass::Owner()
{
	return OwnerAddr;
}
GameObject **ScriptImpClass::Get_Owner_Ptr()
{
	return &OwnerAddr;
}
void ScriptImpClass::Set_Parameters_String(const char *params)
{
	if (!params || !*params)
		return;
	Get_Name();
	char* a = strdup(params);
	if (a[strlen(a) - 1] == '\n')
		a[strlen(a) - 1] = 0;
	int b = 1;
	{
		for (const char* r = a; *r; )
		{
			if (*r++ == ',')
				b++;
		}
	}
	Clear_Parameters();
	mArgC = b;
	mArgV = new char*[b];
	memset(mArgV, 0, b << 2);
	memcpy(a, params, strlen(params));
	int i = 0;
	for (char* r = a; *r; i++)
	{
		char* r2 = r;
		while (*r2 && *r2 != ',')
			r2++;
		if (*r2)
			*r2++ = 0;
		Set_Parameter(i,r);
		r = r2;
	}
	if (mArgC != i) // never true
	{
		Set_Parameter(i,noparams);
	}
	free(a);
}

void ScriptImpClass::Get_Parameters_String(char *params,unsigned int size)
{
	*params = 0;
	unsigned int l = 0;
	for (int i = 0; i < mArgC; i++)
	{
		if (l >= size)
			return;
		if (i > 0)
		{
			l++;
			strcat(params, ",");
		}
		const char* s = Get_Parameter(i);
		l += strlen(s);
		if (l > size)
			continue;
		strcat(params, s);
	}
}
void ScriptImpClass::Save(DWORD saver)
{
	SeralizeInfoStr *d;
	d = seralizeinfo;
	Commands->Begin_Chunk(saver,0x63736176);
	while (d != 0) {
		Commands->Save_Data(saver,d->number,d->size,d->data);
		d = d->next;
	}
	Commands->End_Chunk(saver);
}
void ScriptImpClass::Load(DWORD loader)
{
	unsigned int x;
	int y;
	SeralizeInfoStr *d;
	while (Commands->Open_Chunk(loader,&x) != 0) {
		if (x == 0x63736176) {
			while (Commands->Load_Begin(loader,&y) != 0) {
				d = seralizeinfo;
				 while (d != 0) {
					if (d->number == y) {
						Commands->Load_Data(loader,d->size,d->data);
					}
					d = d->next;
				}
				Commands->Load_End(loader);
			}
		}
		Commands->Close_Chunk(loader);
	};
}
void ScriptImpClass::Save_Data(DWORD unk)
{
}
void ScriptImpClass::Load_Data(DWORD unk)
{
}
void ScriptImpClass::Register_Auto_Save_Variables()
{
}
int ScriptImpClass::CheckPlayerType(GameObject * obj,int type) {
	if (type == 3) {
		GameObject * object = Owner();
		Vector3 pos = Commands->Get_Position(object);
		object = Commands->Get_A_Star(pos);
		if (object == obj) {
			return 0;
		} else {
			return 1;
		}
	}
	if (type == 2) {
		return 0;
	}
	int pltype = Commands->Get_Player_Type(obj);
	if (pltype == type) {
		return 0;
	}
	return 1;
}
void ScriptImpClass::Auto_Save_Variable(int num,int size,void *var)
{
	SeralizeInfoStr *d,*d2;
	if (num < 0 || num > 0xff || size > 0xfa)
		return;
	d = seralizeinfo;
	while (d != 0) {
		if (d->number == num) {
			return;
		}
		d = d->next;
	}
	d2 = new SeralizeInfoStr;
	if (d2 == 0) {
		seralizeinfo = 0;
		return;
	}
	d = seralizeinfo;
	d2->number = num;
	d2->size = size;
	d2->data = var;
	d2->next = d;
	seralizeinfo = d2;
}
ScriptImpClass::~ScriptImpClass() 
{
	while(seralizeinfo) {
		SeralizeInfoStr *s = seralizeinfo;
		seralizeinfo = s->next;
		delete s;
	}
}

ScriptFactory::ScriptFactory(char *n,char *p)
{ 
	name = n;
	params = p;
	next = 0;
	temp = 0;
	ScriptRegistrar::RegisterScript(this);
}
GameObjObserverClass::~GameObjObserverClass() 
{
}
void ScriptRegistrar::UnregisterScript(ScriptFactory *ptr)
{
	ScriptFactory *x = mScriptFactories;
	ScriptFactory *z = 0;
	ScriptFactory *y;
	if (x == 0) {
		return;
	}
	do {
		y = x->GetNext();
		if (x != ptr) {
			if (z == 0) {
				mScriptFactories = y;
			} else {
				z->SetNext(y);
			}
		}
		z = x;
		x = y;				
	} while (y != 0);
}

ScriptFactory *ScriptFactory::GetNext()
{
	return next;
}
char *ScriptFactory::GetName()
{
	return name;
}
char *ScriptFactory::GetParamDescription()
{
	return params;
}
ScriptFactory::~ScriptFactory()
{
	if(temp) {
		ScriptRegistrar::UnregisterScript(this);
		name = 0;
		params = 0;
	} else {
		temp = 1;
	}
}
ScriptFactory *ScriptRegistrar::mScriptFactories;
void ScriptRegistrar::RegisterScript(ScriptFactory *ptr)
{
	ptr->SetNext(mScriptFactories);
	mScriptFactories = ptr;
}

void ScriptFactory::SetNext(ScriptFactory *ptr)
{
	if (next)
		ptr->SetNext(next);
	next = ptr;
}
float MoveArriveDistance = 100;
ScriptFactory* ScriptRegistrar::GetScriptFactory(const char *name) 
{
	ScriptFactory *x = mScriptFactories;
	do {
		if (_strcmpi(x->GetName(),name) == 0) {
		return x;
		}
		x = x->GetNext();
	} while (x != NULL);
	return 0;
}
ScriptFactory* ScriptRegistrar::GetScriptFactory(int number) 
{
	ScriptFactory *x = mScriptFactories;
	int n = 0;
	do {
		if (n == number) {
		return x;
		}
		x = x->GetNext();
		n++;
	} while (x != NULL);
	return 0;
}
int ScriptRegistrar::Count() 
{
	ScriptFactory *x;
	int sn = 0;
	x = mScriptFactories;
	while (x != 0) {
		sn++;
		x = x->GetNext();
	}
	return sn;
}
ScriptImpClass *ScriptRegistrar::CreateScript(const char *name) 
{
	ScriptFactory *x = mScriptFactories;
	do {
		if (_strcmpi(x->GetName(),name) == 0) {
		return x->Create();
		}
		x = x->GetNext();
	} while (x != NULL);
	return 0;
}

void ScriptImpClass::Clear_Parameters()
{
	if (mArgV) {
		while (mArgC--) {
			if(mArgV[mArgC])
				free(mArgV[mArgC]);
		}
		delete[] mArgV;
	}
	mArgV = NULL;
	mArgC = 0;
}

const char* ScriptImpClass::Get_Parameter(const char* v)
{
	return Get_Parameter(Get_Parameter_Index(v));
}
int ScriptImpClass::Get_Int_Parameter(const char* v)
{
	return atoi(Get_Parameter(Get_Parameter_Index(v)));
}

float ScriptImpClass::Get_Float_Parameter(const char* v)
{
	return (float)atof(Get_Parameter(Get_Parameter_Index(v)));
}

char* strtrim(char* v) 
{
	if (v)
	{
		char* r = v;
		while (*r > 0 && *r < 0x21)
			r++;
		strcpy(v, r);
		r = v + strlen(v);
		while (r > v && r[-1] > 0 && r[-1] < 0x21)
			r--;
		*r = 0;
	}
	return v;
}
Vector3 ScriptImpClass::Get_Vector3_Parameter(const char* v)
{
	return Get_Vector3_Parameter(Get_Parameter_Index(v));
}
int ScriptImpClass::Get_Parameter_Index(const char* v)
{
	char b[0x200];
	strncpy(b, Factory->GetParamDescription(), 0x1ff); // ??
	b[0x1ff] = 0;
	char* r = b;
	for (int i = 0; r ; i++)
	{
		char* r2 = r;
		while (*r2 && *r2 != ',')
			r2++;
		if (*r2)
			*r2++ = 0;
		char* r3 = strpbrk(r, "=:\n");
		if (r3)
			*r3 = 0;
		strtrim(r);
		if (!stricmp(r, v))
			return i;
		r = r2;
	}
	return -1;
}

int ScriptImpClass::Get_Parameter_Count()
{
	return mArgC;
}

int ScriptImpClass::Get_Int_Parameter(int v)
{
	return atoi(Get_Parameter(v));
}

float ScriptImpClass::Get_Float_Parameter(int v)
{
	return (float)atof(Get_Parameter(v));
}
void ScriptImpClass::Set_Parameter(int pos,char const *v)
{
	if (mArgV[pos] != 0) {
		delete mArgV[pos];
	}
	mArgV[pos] = strdup(v);
	
}
const char* ScriptImpClass::Get_Parameter(int v)
{
	if ((v >= 0) && (v < mArgC)) {
		return mArgV[v];
	} else {
		return noparams;
	}
}
Vector3 ScriptImpClass::Get_Vector3_Parameter(int v)
{
	Vector3 r;
	r.X = 0;
	r.Y = 0;
	r.Z = 0;
	sscanf(Get_Parameter(v), "%f %f %f", &r.X, &r.Y, &r.Z);
	return r;
}
